#pragma once
/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework Class Library
 * Version 2.00
 * 
 * Boolean Option Base Class
 *      Represents socket option(s) whose underlying data type is a boolean.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
#include "stdafx.h"
#include "SocketOptionBase.h"

using namespace System;
using namespace System::Net;
using namespace System::Net::Sockets;
using namespace Adaptive;
using namespace Adaptive::Foundation;

namespace Adaptive
{
	namespace Network
	{
		namespace Sockets
		{
			/// <summary>
			/// Represents socket option(s) whose underlying data type is a boolean.
			/// </summary>
			public ref class BooleanSocketOption : SocketOptionBase<bool>
			{
			public:
				/*--------------------------------------------------------------------------------
				 * Constructor / Dispose / Destructor Methods
				 *------------------------------------------------------------------------------*/
				#pragma region Constructor / Dispose / Destructor Methods
				/// <summary>
				/// Initializes a new instance of the class.
				/// </summary>
				/// <param name="level">A <see cref="SocketOptionLevel"/> enumerated value indicating the option level.</param>
				/// <param name="name">A <see cref="SocketOptionName"/> enumerated value indicating the option name.</param>
				BooleanSocketOption(SocketOptionLevel level, SocketOptionName name);
				/// <summary>
				/// Initializes a new instance of the class.
				/// </summary>
				/// <param name="level">A <see cref="SocketOptionLevel"/> enumerated value indicating the option level.</param>
				/// <param name="name">A <see cref="SocketOptionName"/> enumerated value indicating the option name.</param>
				/// <param name="value">The initial value for the socket option.</param>
				BooleanSocketOption(SocketOptionLevel level, SocketOptionName name, bool value);
				#pragma endregion
			};
		}
	}
}
