#pragma once
#include "stdafx.h"

/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Core Class Library
 * Version 2.00
 * 
 * Color Depth Enumeration
 *		Lists the options for the color-depth of a display device.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
namespace Adaptive
{
	namespace Win32
	{
		/// <summary>
		/// Lists the options for the color-depth of a display device.
		/// </summary>
		public enum class ColorDepth
		{
			/// <summary>
			/// Indicates the default value is used.
			/// </summary>
			DisplayDefault = 0,
			/// <summary>
			/// Indicates a color depth of 8 bits per pixel - (1 byte, 256 colors).
			/// </summary>
			EightBpp = 8,
			/// <summary>
			/// Indicates a color depth of 16 bits per pixel - (2 bytes, 65536 colors).
			/// </summary>
			SixteenBpp = 16,
			/// <summary>
			/// Indicates a color depth of 24 bits per pixel - (3 bytes, 16 million colors).
			/// </summary>
			TwentyFourBpp = 24,
			/// <summary>
			/// Indicates a color depth of 32 bits per pixel - (4 bytes, 4 billion+ colors).
			/// </summary>
			ThirtyTwoBpp = 32
		};
	}
}