#pragma once
#include "stdafx.h"

using namespace System;

namespace Adaptive
{
	namespace Network
	{
		 namespace Dns
		 {
			/// <summary>
			/// Lists the types of results that may occur with DNS queries.
			/// </summary>
			[Flags()]
			public enum class DnsQueryResults
			{
				/// <summary>
				/// Indicates no result occured from a query.
				/// </summary>
				None = 1,
				/// <summary>
				/// Indicates the DNS query was successful.
				/// </summary>
				Success =	2,
				/// <summary>
				/// Indicates errors occured in the process.
				/// </summary>
				Errors	=	4,
			};
		 }
	}
}