#pragma once
/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework Class Library
 * Version 2.00
 * 
 * Duplicate Handle Options Enumeration
 *      Lists the options for use when duplicating handles.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
#include "stdafx.h"
using namespace System;

namespace Adaptive
{
	namespace Foundation
	{
		/// <summary>
		/// Lists the options for use when duplicating handles.
		/// </summary>
		public enum class DuplicateHandleOptions
		{
			/// <summary> No option selected. </summary>
			None		= 0,
			/// <summary> Indicates the source handle is to be closed. </summary>
			CloseSource = DUPLICATE_CLOSE_SOURCE,
			/// <summary> Indicates the handle is to be duplicated with the same access rights. </summary>
			SameAccess	= DUPLICATE_SAME_ACCESS
		};
	}
}