#pragma once
/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Native Win32 API Class Library
 * Version 2.00
 * 
 * File Cluster Map Entry Collection Class
 *      Provides a custom collection implementation for storing FileClusterMapEntry instances.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
#include "stdafx.h"
#include "FileClusterMapEntry.h"

using namespace System;
using namespace System::Collections;
using namespace System::Collections::Generic;

namespace Adaptive
{
	namespace Foundation
	{
		namespace IO
		{
			/// <summary>
			/// Provides a custom collection implementation for storing FileClusterMapEntry instances.
			/// </summary>
			public ref class FileClusterMapEntryCollection sealed : public GenericCollectionBase<FileClusterMapEntry^>
			{
			public:
				/*------------------------------------------------------------------------
				 * Constructor / Dispose / Destructor Methods
				 *----------------------------------------------------------------------*/
				#pragma region Constructor / Dispose / Destructor Methods
				/// <summary>
				/// Initializes a new instance of the class
				/// </summary>
				/// <remarks>
				/// This is the default constructor.
				/// </remarks>
				FileClusterMapEntryCollection();
				/// <summary>
				/// Deallocates internally allocated objects.
				/// </summary>
				~FileClusterMapEntryCollection();
				#pragma endregion

			protected:
				/*------------------------------------------------------------------------
		         * Protected Methods / Functions
				 *----------------------------------------------------------------------*/
				#pragma region Protected Methods / Functions
				/// <summary>
				/// Gets the unique key for the specified object instance used to idemn
				/// </summary>
				/// <param name="itemToGetKeyFor">The FileClusterMapEntry being appended to the collection.</param>
				/// <returns>
				/// A string value used to identify the object instance.
				/// </returns>
				virtual String^ GetKeyForObject(FileClusterMapEntry^ itemToGetKeyFor) override;
				#pragma endregion
			};
		}
    }
}
