#include "StdAfx.h"
#include "FileClusterMapEntry.h"

using namespace Adaptive::Foundation::IO;

/*--------------------------------------------------------------------------------
 * Constructor / Dispose / Destructor Methods
 *------------------------------------------------------------------------------*/
#pragma region Constructor / Dispose / Destructor Methods

FileClusterMapEntry::FileClusterMapEntry()
{
	_logicalCluster = 0;
	_startVirtualCluster = 0;
	_numberOfClusters = 0;
}
FileClusterMapEntry::FileClusterMapEntry(__int64 logicalClusterNo, __int64 virtualClusterNo, __int64 numberOfClusters)
{
	_logicalCluster = logicalClusterNo;
	_startVirtualCluster = virtualClusterNo;
	_numberOfClusters = numberOfClusters;
}
#pragma endregion

/*------------------------------------------------------------------------
 * Public Properties
 *----------------------------------------------------------------------*/
#pragma region Public Properties

__int64 FileClusterMapEntry::LogicalClusterNumber::get()
{
	return _logicalCluster;
}
void FileClusterMapEntry::LogicalClusterNumber::set(__int64 value)
{
	_logicalCluster = value;
}
__int64 FileClusterMapEntry::StartingVirtualClusterNumber::get()
{
	return _startVirtualCluster;
}
void FileClusterMapEntry::StartingVirtualClusterNumber::set(__int64 value)
{
	_startVirtualCluster = value;
}
__int64 FileClusterMapEntry::NumberOfClusters::get()
{
	return _numberOfClusters;
}
void FileClusterMapEntry::NumberOfClusters::set(__int64 value)
{
	_numberOfClusters = value;
}
__int64 FileClusterMapEntry::NextVirtualClusterNumber::get()
{
	return _startVirtualCluster + _numberOfClusters;
}
#pragma endregion