#pragma once
/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework Class Library
 * Version 2.00
 * 
 * Set Handle Options Enumeration
 *      Lists the options for use when setting handle values.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
#include "stdafx.h"
using namespace System;

namespace Adaptive
{
	namespace Foundation
	{
		/// <summary>
		/// Lists the options for use when setting handle values.
		/// </summary>
		public enum class SetHandleOptions
		{
			/// <summary>Indicates no option was selected.</summary>
			None				= 0,
			/// <summary>Indicates the new handle is to inherit rights from the previous one.</summary>
			Inherit				= HANDLE_FLAG_INHERIT,
			/// <summary>Protect the duplicate handle from closing.</summary>
			ProtectFromClose	= HANDLE_FLAG_PROTECT_FROM_CLOSE
		};
	}
}