#pragma once
/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework Class Library
 * Version 2.00
 * 
 * Socket Connected Event Arguments Class
 *      Provides an event arguments class for post-connection Socket events.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
#include "stdafx.h"
#include "SocketsIncludes.h"
#include "ISocketConnection.h"

using namespace System;

namespace Adaptive
{
	namespace Network
	{
		namespace Sockets
		{
			/// <summary>
			/// Provides an event arguments class for post-connection Socket events.
			/// </summary>
			public ref class SocketConnectedEventArgs : public ConnectionEventArgs
			{
			public:
				/*--------------------------------------------------------------------------------
				 * Constructor / Dispose / Destructor Methods
				 *------------------------------------------------------------------------------*/
				#pragma region Constructor / Dispose / Destructor Methods
				/// <summary>
				/// Initializes a new instance of the class.
				/// </summary>
				/// <param name="newSocket">
				/// The newly connection <see cref="ISocketConnection"/> instance.
				/// </param>
				SocketConnectedEventArgs(ISocketConnection^ newSocket);
				#pragma endregion
			};
		}
	}
}
