#pragma once
/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework Class Library
 * Version 2.00
 * 
 * Socket Option(s) Collection Class
 *      Provides a custom collection implementation for storing SocketOptionBase instances.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
#include "stdafx.h"
#include "SocketOptionBase.h"

using namespace System;
using namespace System::Runtime;
using namespace System::Runtime::InteropServices;
using namespace System::Net;
using namespace System::Net::Sockets;
using namespace Adaptive;
using namespace Adaptive::Foundation;

namespace Adaptive
{
	namespace Network
	{
		namespace Sockets
		{
			/// <summary>
			/// Provides a custom collection implementation for storing <see cref="ISocketOption"/> instances.
			/// </summary>
			public ref class SocketOptionCollection : public GenericCollectionBase<ISocketOption^>
			{
			public:
				/*------------------------------------------------------------------------
				 * Constructor / Dispose / Destructor Methods
				 *----------------------------------------------------------------------*/
				#pragma region Constructor / Dispose / Destructor Methods
				/// <summary>
				/// Initializes a new instance of the class
				/// </summary>
				/// <remarks>
				/// This is the default constructor.
				/// </remarks>
				SocketOptionCollection();

			protected:
				/*------------------------------------------------------------------------
		         * Protected Methods / Functions
				 *----------------------------------------------------------------------*/
				#pragma region Protected Methods / Functions
				/// <summary>
				/// Gets the unique key for the specified object instance used to idemn
				/// </summary>
				/// <param name="itemToGetKeyFor">The FileClusterMapEntry being appended to the collection.</param>
				/// <returns>
				/// A string value used to identify the object instance.
				/// </returns>
				virtual String^ GetKeyForObject(ISocketOption^ itemToGetKeyFor) override;
				#pragma endregion
			};
		}
	}
}
