/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Windows Forms Controls Class Library
 * Version 2.00
 * 
 * Line Style Enumeration
 *		A style enumeration for the <see cref="LineControl"/> class.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;

namespace Adaptive.Foundation.Windows.Forms
{
    /// <summary>
    /// A style enumeration for the <see cref="LineControl"/> class..
    /// </summary>
    public enum LineStyle
    {
        /// <summary>Draw no lines.</summary>
        NoLine = 0,
        /// <summary>Draw a single-pixel width line with the foreground color.</summary>
        SingleLine = 1,
        /// <summary>Draw a single-pixel width line with a 3D inset border.</summary>
        InsetLine = 2,
        /// <summary>Draw a single-pixel width line with a 3D raised border.</summary>
        RaisedLine = 3,
        /// <summary>Draw a single-pixel width line with a specific color.</summary>
        ColorLine = 4,
        /// <summary>Draw a single-pixel width line with a specific color and a 3D inset border.</summary>
        InsetColorLine = 5,
        /// <summary>Draw a single-pixel width line with a color gradient using the specified colors.</summary>
        GradientLine = 6,
        /// <summary>Draw a single-pixel width line with a color gradient using the specified colors and
        /// a 3D inset border.</summary>
        InsetGradientLine = 7
    }
}
