﻿/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Windows Forms Controls Class Library
 * Version 2.00
 * 
 * File Browse Style Enumeration
 *      Lists the common dialog styles for the FileBrowseButton.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;

namespace Adaptive.Foundation.Windows.Forms
{
    /// <summary>
    /// Lists the common dialog styles for the <see cref="FileBrowseButton"/>.
    /// </summary>
    public enum FileBrowseStyle
    {
        /// <summary>
        /// Indicates the Open File common dialog is to be displayed.
        /// </summary>
        OpenFileDialog = 0,
        /// <summary>
        /// Indicates the Save File common dialog is to be displayed.
        /// </summary>
        SaveFileDialog = 1
    }
}