﻿/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Extended Code Document Object Model
 * Version 2.10
 * 
 * AI Project Typers Enumeration
 *      Lists the types of code projects that are supported in the generator.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;

namespace Adaptive.Foundation.CodeDom
{
    /// <summary>
    /// Lists the types of code projects that are supported in the generator.
    /// </summary>
    public enum AiProjectTypes
    {
        /// <summary>
        /// Indicates no language selected.
        /// </summary>
        None = 0,
        /// <summary>
        /// Indicates a .NET Class Library project.
        /// </summary>
        ClassLibrary = 1,
        /// <summary>
        /// Indicates a Windows Forms Application project.
        /// </summary>
        WindowsForms = 2,
        /// <summary>
        /// Indicates a Windows Service project.
        /// </summary>
        WindowsService = 3,
        /// <summary>
        /// Indicates a Windows Forms User Control Library project.
        /// </summary>
        UserControlLibrary = 4,
        /// <summary>
        /// Indicates an ASP.NET Web Application project.
        /// </summary>
        ASPNetProject = 5,
        /// <summary>
        /// Indicates a Console Application.
        /// </summary>
        ConsoleApplication = 6,
        /// <summary>
        /// Indicates a Windows Communication Foundation (WCF) project.
        /// </summary>
        WCFProject = 7,
        /// <summary>
        /// Indicates aun unspecified project type.
        /// </summary>
        OpenEnded = 8
    }
}