﻿/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Extended Code Document Object Model
 * Version 2.10
 * 
 * Visual Studio Languages Enumeration
 *      Lists the languages that Visual Studio supports.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;

namespace Adaptive.Foundation.CodeDom
{
    /// <summary>
    /// Lists the languages that Visual Studio supports.
    /// </summary>
    public enum VisualStudioLanguages
    {
        /// <summary>
        /// Indicates no language selected.
        /// </summary>
        None = 0,
        /// <summary>
        /// Indicates the Visual Basic Language.
        /// </summary>
        VisualBasic = 1,
        /// <summary>
        /// Indicates the Visual C# Language.
        /// </summary>
        CSharp = 2,
        /// <summary>
        /// Indicates the Visual J# Language.
        /// </summary>
        JSharp = 3,
        /// <summary>
        /// Indicates the Visual C++ (Managed) Language.
        /// </summary>
        CPlusPlus = 4,
        /// <summary>
        /// Indicates the F# Language.
        /// </summary>
        FSharp = 5,
        /// <summary>
        /// Indicates a custom or undetermined language.
        /// </summary>
        Custom = 6
    }
}
