﻿/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Extended Code Document Object Model
 * Version 2.10
 * 
 * Visual Studio Versions Enumeration
 *      Lists the versions of Visual Studio that are supported.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;

namespace Adaptive.Foundation.CodeDom
{
    /// <summary>
    /// Lists the versions of Visual Studio that are supported.
    /// </summary>
    public enum VisualStudioVersions  
    {
        /// <summary>
        /// Indicates no version selected.
        /// </summary>
        None = 0,
        /// <summary>
        /// Indicates Visual Studio 2002 (for Framework 1.0).
        /// </summary>
        Version2002 = 70,
        /// <summary>
        /// Indicates Visual Studio 2003 (for Framework 1.1).
        /// </summary>
        Version2003 = 71,
        /// <summary>
        /// Indicates Visual Studio 2005 (for Framework 2.0).
        /// </summary>
        Version2005 = 80,
        /// <summary>
        /// Indicates Visual Studio 2008 (for Framework 2.0+).
        /// </summary>
        Version2008 = 90
    }
}
