﻿using System;
using System.Collections;
using System.Globalization;

namespace Adaptive.Foundation.CodeDom.Native
{
    [Serializable]
    internal class InvariantComparer : IComparer
    {
        // Fields
        internal static readonly InvariantComparer Default = new InvariantComparer();
        private CompareInfo m_compareInfo = CultureInfo.InvariantCulture.CompareInfo;

        // Methods
        internal InvariantComparer()
        {
        }

        public int Compare(object a, object b)
        {
            string str = a as string;
            string str2 = b as string;
            if ((str != null) && (str2 != null))
            {
                return this.m_compareInfo.Compare(str, str2);
            }
            return Comparer.Default.Compare(a, b);
        }
    }
}