/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework
 * Version 2.10
 * 
 * Audit Action Type Enumeration
 *      Provides a list of the available audit actions.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;

namespace Adaptive.Foundation.Data
{
    /// <summary>
    /// Provides a list of the available audit actions.
    /// </summary>
    public enum AuditActionType
    {
        /// <summary>
        /// Indicates no audit statement or action.
        /// </summary>
        None = 0,
        /// <summary>
        /// Indicates an INSERT audit record to be created.
        /// </summary>
        Insert = 1,
        /// <summary>
        /// Indicates an UPDATE audit record to be created.
        /// </summary>
        Update = 2,
        /// <summary>
        /// Indicates a DELETE audit record to be created.
        /// </summary>
        Delete = 3,
        /// <summary>
        /// Indicates a customer type of audit record to be created.
        /// </summary>
        Other = 4
    }
}