/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework
 * Version 2.10
 * 
 * SQL Data Actor Class
 *      Provides a data actor implementation for SQL Server databases.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;
using System.Data;
using System.Data.SqlClient;

namespace Adaptive.Foundation.Data
{
    /// <summary>
    /// Provides a data actor implementation for SQL Server databases.
    /// </summary>
    public sealed class SqlDataActor : DataActorBase
    {
        /*--------------------------------------------------------------------------------
         * Constructor / Dispose / Destructor Methods
		 *------------------------------------------------------------------------------*/
        #region Constructor / Dispose / Destructor Methods
        /// <summary>
        /// Initializes a new instance of the class.
        /// </summary>
        /// <remarks>
        /// This is the default constructor.
        /// </remarks>
        public SqlDataActor()
            : base(new SqlDataProvider())
        {
        }
        /// <summary>
        /// Initializes a new instance of the class.
        /// </summary>
        /// <param name="connectionString">
        /// The connection string defining the SQL connection.
        /// </param>
        public SqlDataActor(string connectionString)
            : base(new SqlDataProvider(), connectionString)
        {
        }
        #endregion
    }
}