/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework
 * Version 2.10
 * 
 * SQL Stored Procedure Class
 *      Provides a definition for executing a SQL Server stored procedure.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;
using System.Data;
using System.Data.SqlClient;

namespace Adaptive.Foundation.Data
{
    /// <summary>
    /// Provides a definition for executing a SQL Server stored procedure.
    /// </summary>
    public class SqlStoredProcedure : StoredProcedureBase
    {
        /*--------------------------------------------------------------------------------
         * Constructor / Dispose / Destructor Methods
		 *------------------------------------------------------------------------------*/
        #region Constructor / Dispose / Destructor Methods
        /// <summary>
        /// Initializes a new instance of the class.
        /// </summary>
        /// <remarks>
        /// This is the default constructor.
        /// </remarks>
        public SqlStoredProcedure(string procedureName)
            : base(procedureName, new SqlDataProvider())
        {
        }
        #endregion
    }
}