﻿/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Secure Notepad Application
 * Version 2.00
 * 
 * Text Document Type Enumeration
 *      Lists the types of text documents that may be processed.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;

namespace Adaptive.Foundation
{
    /// <summary>
    /// Lists the types of text documents that may be processed.
    /// </summary>
    public enum TextDocumentType
    {
        /// <summary>
        /// Indicates a normal, clear text file.
        /// </summary>
        ClearText = 0,
        /// <summary>
        /// Indicates a secured text file.
        /// </summary>
        SecureText = 1
    }
}