/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework Class Library
 * Version 2.00
 * 
 * AI Checksum Validation Failed Exception Class
 *      Provides an exception definition for cases where a CRC-32 comparison
 * of data contents fails.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;

namespace Adaptive.Foundation.IO
{
    /// <summary>
    /// Provides an exception definition for cases where a CRC-32 comparison
    /// of data contents fails.
    /// </summary>
    public class AiCrcFailedException : System.IO.IOException
    {
        /*--------------------------------------------------------------------------------
         * Private Constants Declarations
         *------------------------------------------------------------------------------*/
        #region Private Constants Declarations

        private const string MESSAGE = "CRC-32 value data validation failed.";

        #endregion

        /*--------------------------------------------------------------------------------
         * Constructor / Dispose / Destructor Methods
         *------------------------------------------------------------------------------*/
        #region Constructor / Dispose / Destructor Methods
        /// <summary>
        /// Initializes a new instance of the class.
        /// </summary>
        /// <remarks>
        /// This is the default constructor.
        /// </remarks>
        public AiCrcFailedException()
            : base(MESSAGE)
        {
        }
        #endregion
    }
}
