/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework Class Library
 * Version 2.00
 * 
 * AI Hash Code Validation Failed Exception Class
 *      Provides an exception definition for cases where a hash code comparison
 * of data contents fails.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;

namespace Adaptive.Foundation.IO
{
    /// <summary>
    /// Provides an exception definition for cases where A.I. formatted files
    /// of data contents fails.
    /// </summary>
    public class AiHashCodeFailedException : System.IO.IOException
    {
        /*--------------------------------------------------------------------------------
         * Private Constants Declarations
         *------------------------------------------------------------------------------*/
        #region Private Constants Declarations

        private const string MESSAGE = "Hash code validation failed.";

        #endregion

        /*--------------------------------------------------------------------------------
         * Constructor / Dispose / Destructor Methods
         *------------------------------------------------------------------------------*/
        #region Constructor / Dispose / Destructor Methods
        /// <summary>
        /// Initializes a new instance of the class.
        /// </summary>
        /// <remarks>
        /// This is the default constructor.
        /// </remarks>
        public AiHashCodeFailedException()
            : base(MESSAGE)
        {
        }
        #endregion
    }
}
