﻿/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework Class Library
 * Version 2.00
 * 
 * ZIP Constants Class
 * 		Provides an internal list of the constants used to define the data element
 * signature values within a PK ZIP file.	
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;

namespace Adaptive.Foundation.IO.Zip
{
    /// <summary>
    /// Provides an internal list of the constants used to define the data element
    /// signature values within a PK ZIP file.
    /// </summary>
    internal class ZipConstants
    {
        //Name							Hex			Int32		Bytes
        //-----------------------------------------------------------------------
        //Local File Header 			0x04034b50	67324752	80,75,3,4
        //Archive Extra Data 			0x08064b50	134630224 	80,75,6,8
        //Data Descriptor				0x08074b50  134695760   80,75,7,8 
        //Central file header 			0x02014b50	33639248	80,75,1,2
        //Header signature 				0x05054b50	84233040	80,75,5,5
        //Zip64 end of central dir 		0x06064b50	101075792	80,75,6,6
        //zip64 end-central dir locator 0x07064b50fs	117853008	80,75,6,7
        //End of central dir 			0x06054b50	101010256	80,75,5,6

        public const int SIGNATURE_LOCALFILE_HEADER = 0x04034b50;
        public const int SIGNATURE_ARCHIVE_EXTRA_DATA = 0x08064b50;
        public const int SIGNATURE_DATA_DESCRIPTOR = 0x08074b50;
        public const int SIGNATURE_CENTRALDIRECTORY_HEADER = 0x02014b50;
        public const int SIGNATURE_DIGITAL_SIGANTURE = 0x05054b50;
        public const int SIGNATURE_ZIP64_END_CENTRALDIRECTORY = 0x06064b50;
        public const int SIGNATURE_ZIP64_END_CENTRALDIRECTORY_LOCATOR = 0x07064b50;
        public const int SIGNATURE_END_CENTRALDIRECTORY = 0x06054b50;

    }
}
