﻿/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework
 * Version 2.10
 * 
 * CNR Exception Class
 *      Provides a basic definition for repsenting a CNR exception.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;
using System.Text;
using Adaptive.Foundation;

namespace Adaptive.Foundation.Network.Cnr
{
    /// <summary>
    ///Provides a basic definition for repsenting a CNR exception.
    /// </summary>
    public class CnrException : Exception
    {
        /*--------------------------------------------------------------------------------
         * Constructor / Dispose / Destructor Methods
         *------------------------------------------------------------------------------*/
        #region Constructor / Dispose / Destructor Methods
        /// <summary>
        /// Initializes a new instance of the class.
        /// </summary>
        /// <remarks>
        /// This is the default constructor.
        /// </remarks>
        public CnrException()
            : base()
        {
        }
        /// <summary>
        /// Initializes a new instance of the class.
        /// </summary>
        /// <param name="message">
        /// The error message description.
        /// </param>
        public CnrException(string message)
            : base(message)
        {
        }
        /// <summary>
        /// Initializes a new instance of the class.
        /// </summary>
        /// <param name="innerException">
        /// The inner <see cref="Exception"/> that was captured.
        /// </param>
        public CnrException(Exception innerException)
            : base(string.Empty, innerException)
        {
        }
        /// <summary>
        /// Initializes a new instance of the class.
        /// </summary>
        /// <param name="message">
        /// The error message description.
        /// </param>
        /// <param name="innerException">
        /// The inner <see cref="Exception"/> that was captured.
        /// </param>
        public CnrException(string message, Exception innerException)
            : base(message, innerException)
        {
        }
        #endregion

    }
}