﻿/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework - CNR Framework Section
 * Version 2.10
 * 
 * CNR Authentication Required Event Delegate Class
 *      Provides an event delegate class for CNR Authentication-query events.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;
using Adaptive.Foundation;

namespace Adaptive.Foundation.Network.Cnr
{
    /// <summary>
    /// Provides an event delegate class for CNR Authentication-query events.
    /// </summary>
    /// <param name="sender">The object raising the event.</param>
    /// <param name="e">
    /// A <see cref="CnrAuthenticationRequiredEventArgs"/> event arugments instance containing the 
    /// neccessary authentication information.
    /// </param>
    public delegate void CnrAuthenticationRequiredEventHandler(object sender, CnrAuthenticationRequiredEventArgs e);
}