﻿/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework - CNR Framework Section
 * Version 2.10
 * 
 * CNR Response Reception Event Delegate Class
 *      Provides an event delegate class for CNR response receipt events.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;
using Adaptive.Foundation;

namespace Adaptive.Foundation.Network.Cnr
{
    /// <summary>
    /// Provides an event delegate class for CNR response receipt events.
    /// </summary>
    /// <param name="sender">The object raising the event.</param>
    /// <param name="e">
    /// A <see cref="CnrResponseReceivedEventArgs"/> event arugments instance containing the 
    /// command information.
    /// </param>
    public delegate void CnrResponseReceptionEventHandler(object sender, CnrResponseReceivedEventArgs e);
}