/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework Class Library
 * Version 2.00
 * 
 * Cryptographic Operation Type Enumeration
 *      Lists the cryptographic operations that may be performed.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;

namespace Adaptive.Foundation.Security
{
    /// <summary>
    /// Lists the cryptographic operations that may be performed.
    /// </summary>
    public enum CryptographicOperationType
    {
        /// <summary>
        /// Indicates no operation was specified.
        /// </summary>
        None = 0,
        /// <summary>
        /// Indicates a data encryption operation.
        /// </summary>
        Encrypt = 1,
        /// <summary>
        /// Indicates a data decryption operation.
        /// </summary>
        Decrypt = 2,
        /// <summary>
        /// Indicates a hash generation operation.
        /// </summary>
        GenerateHash = 3,
        /// <summary>
        /// Indicates a data / hash validation operation.
        /// </summary>
        Validatation = 4
    }
}