/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - Foundation Framework Class Library
 * Version 2.00
 * 
 * Invalid Algorithm Exception Class
 *      Provides a custom exception class for cases where an invalid cryptographic
 * algorithm is specified or used.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;

namespace Adaptive.Foundation.Security
{
    /// <summary>
    /// Provides a custom exception class for cases where an invalid cryptographic
    /// algorithm is specified or used.
    /// </summary>
    public sealed class InvalidAlgorithmException : Exception
    {
        /*--------------------------------------------------------------------------------
         * Private Constants Declarations
         *------------------------------------------------------------------------------*/
        #region Private Constants Declarations

        private const string MESSAGE = "The algorithm selected for the cryptographic operation cannot be performed by the current object.";

        #endregion

        /*--------------------------------------------------------------------------------
         * Constructor / Dispose / Destructor Methods
         *------------------------------------------------------------------------------*/
        #region Constructor / Dispose / Destructor Methods
        /// <summary>
        /// Initializes a new instance of the class.
        /// </summary>
        /// <remarks>
        /// This is the default constructor.
        /// </remarks>
        public InvalidAlgorithmException()
            : base(MESSAGE)
        {
        }
        #endregion

    }
}