﻿/*--------------------------------------------------------------------------------
 * Adaptive Intelligence - WordNet Component/Document Object Model Library
 * Version 2.10
 * 
 * WMI Query Result Collection Class
 *      Provides a custom collection for storing WmiQueryResult instances.
 *------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------
 * System Imports
 *------------------------------------------------------------------------------*/
using System;
using Adaptive.Foundation;
using Adaptive.Foundation.Collections;

namespace Adaptive.Foundation.SysTools
{
    /// <summary>
    /// Provides a custom collection for storing <see cref="WmiQueryResult"/> instances.
    /// </summary>
    public class WmiQueryResultCollection : GenericCollectionBase<WmiQueryResult>
    {
        /*--------------------------------------------------------------------------------
         * Constructor / Dispose / Destructor Methods
         *------------------------------------------------------------------------------*/
        #region Constructor / Dispose / Destructor Methods
        /// <summary>
        /// Initializes a new instance of the class.
        /// </summary>
        /// <remarks>
        /// This is the default constructor.
        /// </remarks>
        public WmiQueryResultCollection()
            : base()
        {
        }
        #endregion

        /*--------------------------------------------------------------------------------
         * Protected Methods / Event Methods
         *------------------------------------------------------------------------------*/
        #region Protected Methods / Event Methods
        /// <summary>
        /// Gets the unique key value to associate with the specifeid object instance 
        /// when stored in the collection.
        /// </summary>
        /// <param name="itemToGetKeyFor">
        /// A <see cref="WmiQueryResult"/> class beiong appended to the collection instance.
        /// </param>
        /// <returns>
        /// The reference key value for the instance.
        /// </returns>
        protected override string GetKeyForObject(WmiQueryResult itemToGetKeyFor)
        {
            if (itemToGetKeyFor != null)
                return itemToGetKeyFor.Name;
            else
                return string.Empty;
        }
        #endregion

    }
}